@echo off

setlocal

rem Edit path to the vcvars32.bat file in your Visual C++ installation
rem call "C:\Program Files (x86)\Microsoft Visual Studio\2019\Professional\VC\Auxiliary\Build\vcvars32.bat"

set CpuType=%~1

if "%CpuType%" == "" set CpuType=x86

if not defined VCINSTALLDIR (

  echo Build environment is not set
  exit /b 1

)

set CppFiles=main.cpp wrappers.cpp

set OutDir=out\%CpuType%
set OutFile=tagapi.dll

set PreproDefs=/DUNICODE /D_UNICODE
set LibDirs=..\apilib\out\%CpuType%
set LibFiles=user32.lib setupapi.lib winmm.lib avrt.lib



set ObjFiles=

for %%F in (%CppFiles%) do (

  call set ObjFiles=%%ObjFiles%% "%OutDir%\%%~nF.obj"

)

if not exist "%OutDir%\" (

  md "%OutDir%"
  if errorlevel 1 exit /b 1

)

echo Compiling C++ files

cl /nologo /c /MP %PreproDefs% /Fo"%OutDir%\\" %CppFiles%
if errorlevel 1 exit /b 1

set ObjFiles=

for %%F in (%CppFiles%) do (

  call set ObjFiles=%%ObjFiles%% "%OutDir%\%%~nF.obj"

)

for %%F in ("%OutFile%") do set ImpLibFile=%%~nF.lib

echo Linking

link /nologo /dll /out:"%OutDir%\%OutFile%" /implib:"%OutDir%\%ImpLibFile%" /libpath:"%LibDirs%" %ObjFiles% %ResFiles% %LibFiles%
if errorlevel 1 exit /b 1

echo "%OutDir%\%OutFile%" successfully built
