#include "stdafx.h"






__pragma (comment (lib, "tagapi.lib"))





// #############################################################################################
//
// Variables
// =============================================================================================
// 
// #############################################################################################





HINSTANCE DllInstance = 0;

wchar_t ExePath [MAX_PATH];
PCTSTR ExeFile = nullptr;

UINT DllRefCount = 0;           // DLL reference count



#if _Debug

  DebugContext Dbg (nullptr, 6, L"tagdll");

#endif





// #############################################################################################
//
// Functions
// =============================================================================================
// 
// #############################################################################################





//
// DLL entry function
// =============================================================================================
//

extern "C" BOOL WINAPI DllMain (HMODULE const Instance, DWORD const Reason, PVOID const Reserved) {

  Unreferenced (Reserved);



#if _Debug

  static PCTSTR const Reasons [] = {
    L"PROCESS_DETACH", L"PROCESS_ATTACH", L"THREAD_ATTACH", L"THREAD_DETACH"
  };

  Assert (Reason < NumArrayElems (Reasons));

#endif _Debug



  bool Result = false;



  switch (Reason) {
    
    case DLL_PROCESS_ATTACH: {

      Assert (DllRefCount == 0);

      do {

        DllInstance = Instance;

        //DisableThreadLibraryCalls (Instance);



#if _Debug

        Dbg.SetPrintLevel (6);

        Debug (8, L"%s, API version %u", ProductName, ApiVersion);

#endif // _Debug



        if (GetModuleFileName (nullptr, ExePath, NumArrayElems (ExePath)) == 0) {

          Debug (9, L"Cannot get EXE path (%s)", LastErrorText ());

          break;

        }

        Assert (ExeFile == nullptr);

        ExeFile = wcsrchr (ExePath, L'\\');

        Assert (ExeFile != nullptr);

        ++ExeFile;

        Debug (8, L"Loading into process %u (%.80s)", GetCurrentProcessId (), ExeFile);

        Result = true;

      } OnlyOnce;

      break;

    } // DLL_PROCESS_ATTACH



    case DLL_PROCESS_DETACH: {

      Assert (ExeFile != nullptr);

      Debug (8, L"Unloading from process %u (%.80s)", GetCurrentProcessId (), ExeFile);

      Assert (DllRefCount == 0);

      break;

    }



    case DLL_THREAD_ATTACH: {

      Debug (6, L"Attached to thread %u", GetCurrentThreadId ());

      break;

    }



    case DLL_THREAD_DETACH: {

      Debug (6, L"Detached from thread %u", GetCurrentThreadId ());

      break;

    }



  } // switch (Reason)



  Debug (6, L"Returning from DLL entry (%s) with %u", Reasons [Reason], Result);
                             
  return Result;

}
