#include "stdafx.h"





#if _LegacyWrappers





// #############################################################################################
//
// TagDriver class wrappers
// =============================================================================================
// 
// #############################################################################################





extern "C" HRESULT _Export _stdcall Driver_Create (TagDriver * * const Obj, GUID const * const ClassId) {

  return TagDriver::Create (*Obj, *ClassId);

}





extern "C" void _Export _stdcall Driver_Delete (TagDriver * const Drv) {

  Assert (Drv != nullptr);

  Drv->Delete ();

}





extern "C" bool _Export _stdcall Driver_IsOpen (TagDriver const * const Drv) {

  Assert (Drv != nullptr);
  Drv->Check ();

  return Drv->IsOpen ();

}





extern "C" HRESULT _Export _stdcall Driver_Open (TagDriver * const Drv) {

  Assert (Drv != nullptr);

  return Drv->Open ();

}





extern "C" void _Export _stdcall Driver_Close (TagDriver * const Drv) {

  Assert (Drv != nullptr);

  return Drv->Close ();

}





extern "C" HRESULT _Export _stdcall Driver_CreatePipe (TagDriver * const Drv, TagPipe * & Pipe, bool const Capture) {

  Assert (Drv != nullptr);

  return Drv->CreatePipe (Pipe, Capture);

}





// #############################################################################################
//
// TagPipe class wrappers
// =============================================================================================
// 
// #############################################################################################





extern "C" bool _Export _stdcall Pipe_IsCapt (TagPipe const * const Pipe) {

  Assert (Pipe != nullptr);

  return Pipe->IsCapt ();

}





extern "C" bool _Export _stdcall Pipe_IsOpen (TagPipe const * const Pipe) {

  Assert (Pipe != nullptr);

  return Pipe->IsOpen ();

}





extern "C" PCTSTR _Export _stdcall Pipe_GetType (TagPipe const * const Pipe) {

  Assert (Pipe != nullptr);

  return Pipe->GetType ();

}





extern "C" bool _Export _stdcall Pipe_IsRunningState (TagPipe const * const Pipe) {

  Assert (Pipe != nullptr);

  return Pipe->IsRunningState ();

}






extern "C" void _Export _stdcall Pipe_Delete (TagPipe * const Pipe) {

  Assert (Pipe != nullptr);

  Pipe->Delete ();

}





extern "C" HRESULT _Export _stdcall Pipe_Open (TagPipe * const Pipe, PCTSTR const DriverInterface) {

  Assert (Pipe != nullptr);

  return Pipe->Open (DriverInterface);

}





extern "C" void _Export _stdcall Pipe_Close (TagPipe * const Pipe) {

  Assert (Pipe != nullptr);

  Pipe->Close ();

}





extern "C" _Export CommonDataDesc * _stdcall Pipe_GetCommonData (TagPipe * const Pipe) {

  Assert (Pipe != nullptr);

  return &Pipe->GetCommonData ();

}





extern "C" HRESULT _Export _stdcall Pipe_DriverRequest (
  TagPipe * const Pipe,
  UINT const Func,
  DriverReq * const Req, LocSize const ReqSize,
  void * const Data, LocSize const DataSize,
  LocSize * const RetSize
) {

  Assert (Pipe != nullptr);

  return Pipe->DriverRequest (Func, *Req, ReqSize, Data, DataSize, RetSize);

}





extern "C" HRESULT _Export _stdcall Pipe_SetFormat (
  TagPipe * const Pipe, UINT const SR, UINT const BPS, UINT const NC, UINT const BPC, UINT const CC
) {

  Assert (Pipe != nullptr);

  return Pipe->SetFormat (SR, BPS, NC, BPC, CC);

}





extern "C" HRESULT _Export _stdcall Pipe_SetMinimalBufferSize (TagPipe * const Pipe, UINT const Frames) {

  Assert (Pipe != nullptr);

  return Pipe->SetMinimalBufferSize (Frames);

}





extern "C" HRESULT _Export _stdcall Pipe_SetNotificationEvent (TagPipe * const Pipe, HANDLE const Event) {

  Assert (Pipe != nullptr);

  return Pipe->SetNotificationEvent (Event);

}





extern "C" HRESULT _Export _stdcall Pipe_Notify (TagPipe * const Pipe, NTSTATUS const Code) {

  Assert (Pipe != nullptr);

  return Pipe->Notify (Code);

}





extern "C" HRESULT _Export _stdcall Pipe_AdvanceDevicePosition (TagPipe * const Pipe, UINT const Frames) {

  Assert (Pipe != nullptr);

  return Pipe->AdvanceDevicePosition (Frames);

}





extern "C" HRESULT _Export _stdcall Pipe_ResetDevicePosition (TagPipe * const Pipe) {

  Assert (Pipe != nullptr);

  return Pipe->ResetDevicePosition ();

}





// #############################################################################################
//
// TagHost class wrappers
// =============================================================================================
// 
// #############################################################################################





extern "C" bool _Export _stdcall Host_IsCapt (TagHost * const Host) {

  Assert (Host != nullptr);

  return Host->IsCapt ();

}





extern "C" bool _Export _stdcall Host_IsStarted (TagHost * const Host) {

  Assert (Host != nullptr);

  return Host->IsStarted ();

}





extern "C" _Export PCTSTR _stdcall Host_GetType (TagHost * const Host) {

  Assert (Host != nullptr);

  return Host->GetType ();

}





extern "C" _Export CommonDataDesc const * _stdcall Host_GetCommonData (TagHost * const Host) {

  Assert (Host != nullptr);

  return &Host->GetCommonData ();

}






extern "C" HRESULT _Export _stdcall Host_Create (
  TagHost ** const Obj, TagDriver * const Drv, bool const Capture, CallbackInterface * const CB
) {

  Assert (Obj != nullptr && Drv != nullptr && CB != nullptr);

  return TagHost::Create (*Obj, *Drv, Capture, *CB);

}





extern "C" void _Export _stdcall Host_Delete (TagHost * const Host) {

  Assert (Host != nullptr);

  return Host->Delete ();

}





extern "C" HRESULT _Export _stdcall Host_Start (TagHost * const Host, WaveFormat const * const Format, UINT const MinBufMs) {

  Assert (Host != nullptr && Format != nullptr);

  return Host->Start (*Format, MinBufMs);

}





extern "C" HRESULT _Export _stdcall Host_Stop (TagHost * const Host) {

  Assert (Host != nullptr);

  return Host->Stop ();

}





extern "C" HRESULT _Export _stdcall Host_EventLoop (TagHost * const Host, UINT const PollPeriodMs) {

  Assert (Host != nullptr);

  return Host->EventLoop (PollPeriodMs);

}





#endif _LegacyWrappers
