@echo off

setlocal

rem Edit path to the vcvars32.bat file in your Visual C++ installation
rem call "C:\Program Files (x86)\Microsoft Visual Studio\2019\Professional\VC\Auxiliary\Build\vcvars32.bat"

set CpuType=%~1

if "%CpuType%" == "" set CpuType=x86

if not defined VCINSTALLDIR (

  echo Build environment is not set
  exit /b 1

)

set CppFiles=driver.cpp host.cpp pipe.cpp utils.cpp

set OutDir=out\%CpuType%
set OutFile=tagapi.lib

set PreproDefs=/DUNICODE /D_UNICODE



set ObjFiles=

for %%F in (%CppFiles%) do (

  call set ObjFiles=%%ObjFiles%% "%OutDir%\%%~nF.obj"

)

if not exist "%OutDir%\" (

  md "%OutDir%"
  if errorlevel 1 exit /b 1

)

cl.exe /nologo /c /MP %PreproDefs% /Fo"%OutDir%\\" %CppFiles%
if errorlevel 1 exit /b 1

lib.exe /nologo /out:"%OutDir%\%OutFile%" %ObjFiles%
if errorlevel 1 exit /b 1

echo "%OutDir%\%OutFile%" successfully built
