@echo off

setlocal

rem Edit path to the vcvars32.bat file in your Visual C++ installation
rem call "C:\Program Files (x86)\Microsoft Visual Studio\2019\Professional\VC\Auxiliary\Build\vcvars32.bat"

set CpuType=%~1

if "%CpuType%" == "" set CpuType=x86

if not defined VCINSTALLDIR (

  echo Build environment is not set
  exit /b 1

)

set CppFiles=main.cpp utils.cpp
set RcFiles=testapp.rc
set LinkWithDll=0

set OutDir=out\%CpuType%
set OutFile=testapp.exe

set PreproDefs=/DUNICODE /D_UNICODE
set LibFiles=user32.lib comdlg32.lib setupapi.lib winmm.lib avrt.lib



if "%LinkWithDll%" == "1" (

  set LibType=DLL
  set DirSfx=dll

) else (

  set LibType=static library
  set DirSfx=lib

)

set LibDirs=..\api%DirSfx%\out\%CpuType%


set ObjFiles=

for %%F in (%CppFiles%) do (

  call set ObjFiles=%%ObjFiles%% "%OutDir%\%%~nF.obj"

)

if not exist "%OutDir%\" (

  md "%OutDir%"
  if errorlevel 1 exit /b 1

)

echo Compiling C++ files

cl /nologo /c /MP %PreproDefs% /Fo"%OutDir%\\" %CppFiles%
if errorlevel 1 exit /b 1

set ObjFiles=

for %%F in (%CppFiles%) do (

  call set ObjFiles=%%ObjFiles%% "%OutDir%\%%~nF.obj"

)

echo Compiling resources

set ResFiles=

for %%F in (%RcFiles%) do (

  rc %PreproDefs% "/fo%OutDir%\%%~nF.res" "%%F"
  if errorlevel 1 exit /b 1

  call set ResFiles=%%ResFiles%% "%OutDir%\%%~nF.res"

)

echo Linking with %LibType%

link /nologo /out:"%OutDir%\%OutFile%" /libpath:"%LibDirs%" %ObjFiles% %ResFiles% %LibFiles%
if errorlevel 1 exit /b 1

echo "%OutDir%\%OutFile%" successfully built
