// #############################################################################################
//
// Classes
// =============================================================================================
// 
// #############################################################################################





class Worker : public CallbackInterface {

  FakeCopyConstructor (Worker)
  FakeAssignmentOperator (Worker)

  TagDriver & Driver;
  bool const Capture;

  TagHost * Host;

  HWND Dlg;

  wchar_t FilePath [MAX_PATH];

  HANDLE Thread;
  bool volatile ThreadExitRequest;

  WaveFormat Fmt;
  PBYTE FileData;
  LocSize FileSize;
  LocSize FilePos;

#if _Debug

  DebugContext Dbg;

#endif // _Debug

public:

  Worker (TagDriver & Drv, bool const Capt);
  virtual ~Worker ();

  bool IsCapt () const { return Capture; }
  PCTSTR GetType () const { return IsCapt ()? L"capture" : L"render"; }
  HWND GetDlg () const { return Dlg; }
  HANDLE GetThread () const { return Thread; }
  bool IsStarted () const { return (GetThread () != 0); }



  // From CallbackInterface

  LocSize CopyData (void * const Addr, LocSize const Bytes);



  void SetDlg (HWND const D) {
    Assert (D != 0);
    Dlg = D;
  }

  void EnableNonRealtimeControls (bool const Enable);

  HRESULT ReadDataFromFile ();
  HRESULT WriteDataToFile ();

  HRESULT SelectInputFile ();
  HRESULT SelectOutputFile ();

  HRESULT Start ();
  HRESULT Stop ();

  HRESULT EventLoop ();

  HRESULT ThreadProc ();
  static DWORD WINAPI ThreadProcOuter (void * const Arg);

  INT_PTR HostDialogProc (HWND const Dlg, UINT const Msg, WPARAM const WP, LPARAM const LP);

  static INT_PTR WINAPI HostDialogProcOuter (
    HWND const Dlg, UINT const Msg, WPARAM const WP, LPARAM const LP
  );

};





// #############################################################################################
//
// Variables
// =============================================================================================
// 
// #############################################################################################





#if _Debug

  extern DebugContext Dbg;

#endif _Debug
