#pragma warning (disable: \
  4214 /* nonstandard extension used : bit field types other than int */ \
  4201 /* nonstandard extension used : nameless struct/union */ \
  4010 /* single-line comment contains line-continuation character */ \
  4115 /* named type definition in parentheses */ \
  4204 /* nonstandard extension used- non-constant aggregate initializer */ \
  4514 /* unreferenced inline function has been removed */ \
  4711 /* function selected for automatic inline expansion */ \
)



#if defined (_DEBUG) && !defined (DBG)

  #define DBG 1

#elif defined (DBG) && !defined (_DEBUG)

  #define _DEBUG

#endif



#ifdef _DEBUG

  #define _Debug 1

#else

  #define _Debug 0

#endif



#ifndef WIN32_LEAN_AND_MEAN

  #define WIN32_LEAN_AND_MEAN

#endif



#if defined (_M_IX86) && !defined (_X86_)

  #define _X86_

#endif



#define STRICT




#if _Debug

  #pragma warning (disable: \
    4505 /* unreferenced local function has been removed */ \
  )

#endif





#define _StrX(x) #x
#define _S(x) _StrX (x)
#define _UStrX(x) L#x
#define _US(x) _UStrX (x)


#if _MSC_VER >= 1300

  #define Break() __debugbreak ()

#else

  #define Break() _asm { int 3 }

#endif // _MSC_VER



#define SetBits(v,m) (v |= m)
#define ResetBits(v,m) (v &= ~(m))
#define TestBits(e,m) ((e) & (m))



#define NumArrayElems(a) (sizeof (a) / sizeof (*(a)))
#define SizeOfArray NumArrayElems



#define Unreferenced(x) (void) (x)



#ifndef nullptr

  __if_not_exists (nullptr) {

    #define nullptr 0

  }

#endif



#define Trace Debug



#if _Debug

  #define _stdcall

  #define Debug DebugPrintf

  #define IfDebug(x) x

  #define Assert(Condition) \
    \
    if (!(Condition)) { \
      /* DebugPrintf (9, L"Assert: (" #Condition L") " __FILE__ L", %u", __LINE__); */ \
      Break (); \
    } \

  #define AssertIf(_if,_then) Assert (!(_if) || (_then))

  #define Verify Assert

  // A pervert way to check compilation time conditions

  #define Assume(Cond) extern wchar_t _AssumeDummyVariable [!!(Cond)]

  #define Check(Obj) (Obj)->CheckObject ()
  #define FullCheck(Obj) (Obj)->FullCheckObject ()
  #define CheckClass(Class) Class::CheckStatic ()

  // Define Zero, False and True as variables to prevent C4127 warning

  static int Zero = 0, False = 0, True = 1;

#else // _Debug

  #define _fastcall

  #pragma warning (disable: 4002)
  #define Debug(x)

  #define IfDebug(x)
  #define Assert(Condition) __assume (Condition)

  #define AssertIf(_if,_then)

  #define Verify

  #define Assume(Cond)

  #define Check(Obj)
  #define FullCheck(Obj)
  #define CheckClass(Class)

  // These warnings are enabled only during debug

  #pragma warning (disable: \
    4127 /* conditional expression is constant */ \
    4727 /* conditional expression is constant */ \
  )

  #define Zero 0
  #define False false
  #define True true

#endif // _Debug


//
// Define one-time loop condition to prevent C4127 "constant expression" warning

#define While(Cond) \
  __pragma (warning (push)) \
  __pragma (warning (disable:4127)) \
  while (Cond) \
  __pragma (warning (pop)) \

#define WhileFalse While (false)
#define OnlyOnce While (false)
#define WhileTrue While (true)
#define DoForever While (true)
